---
title: TextEncoder.prototype.encodeInto()
slug: Web/API/TextEncoder/encodeInto
tags:
  - API
  - Experimental
  - Method
  - Reference
  - TextEncoder
  - encodeInto
---
<p>{{APIRef("Encoding API")}}{{seecompattable}}</p>

<p>The <strong><code>TextEncoder.prototype.encodeInto()</code></strong> method takes a {{domxref("USVString")}} to encode and a destination {{jsxref("Uint8Array")}} to put resulting UTF-8 encoded text into, and returns a dictionary object indicating the progress of the encoding. This is potentially more performant than the older <code>encode()</code> method especially when the target buffer is a view into a Wasm heap.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>b1</var> = <var>encoder</var>.encodeInto(<var>string</var>, <var>uint8Array</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>string</var></code></dt>
 <dd>Is a {{DOMxRef("USVString")}} containing the text to encode.</dd>
 <dt><code><var>uint8Array</var></code></dt>
 <dd>Is a {{DOMxRef("Uint8Array")}} object instance to place the resulting UTF-8 encoded text into.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A <code>TextEncoderEncodeIntoResult</code> dictionary, which contains two members:</p>

<dl>
 <dt><code>read</code></dt>
 <dd>The number of UTF-16 units of code from the source that has been converted over to UTF-8. This may be less than <code>string.length</code> if <code>uint8Array</code> did not have enough space.</dd>
 <dt><code>written</code></dt>
 <dd>The number of bytes modified in the destination <code>Uint8Array</code>. The bytes written are guaranteed to form complete UTF-8 byte sequences.</dd>
</dl>

<h2 id="Encode_Into_A_Specific_Position">Encode Into A Specific Position</h2>

<p><var>encoder</var>.encodeInto always puts its output at the start of the array. However, it is sometimes useful to make the output start at a particular index. The solution is <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray/subarray">TypedArray.prototype.subarray()</a>. Observe.</p>

<pre class="brush: js notranslate">var encoder = new TextEncoder;
function encodeIntoAtPosition(string, u8array, position) {
    return encoder.encodeInto(string, position ? u8array.subarray(position|0) : u8array);
}

var u8array = new Uint8Array(8);
encodeIntoAtPosition("hello", u8array, 2);
console.log( "" + u8array.join() ); // 0,0,104,101,108,108,111,0
</pre>

<h2 id="Buffer_Sizing">Buffer Sizing</h2>

<p>To convert a JavaScript string <code>s</code>, the output space needed for full conversion is never less than <code>s.length</code> bytes and never greater than <code>s.length * 3</code> bytes. If the output allocation (typically within Wasm heap) is expected to be short-lived, it makes sense to allocate <code>s.length * 3</code> bytes for the output, in which case the first conversion attempt is guaranteed to convert the whole string. Note that the <code>s.length * 3</code> is rare because the string would have to be packed with some of the few characters that expant into 3 bytes. It is unlikely that long text will exceed <code>s.length * 2</code> bytes in length. Thus, a more optimistic approach might be to allocate <code>s.length * 2 + 5</code> bytes, and perform reallocation in the rare circumstance that the optimistic prediction was wrong. </p>

<p>If the output is expected to be long-lived, it makes sense to compute minimum allocation <code>roundUpToBucketSize(s.length)</code>, the maximum allocation size <code>s.length * 3</code>, and to have a chosen (as a tradeoff between memory usage and speed) threshold <code>t</code> such that if <code>roundUpToBucketSize(s.length) + t &gt;= s.length * 3</code>, you allocate for <code>s.length * 3</code>. Otherwise, first allocate for <code>roundUpToBucketSize(s.length)</code> and convert. If the <code>read</code> item it the return dictionary is <code>s.length</code>, the conversion is done. If not, reallocate the target buffer to <code>written + (s.length - read) * 3</code> and then convert the rest by taking a substring of <code>s</code> starting from index <code>read</code> and a subbuffer of the target buffer starting from index <code>written</code>.</p>

<p>Above <code>roundUpToBucketSize()</code> is a function that rounds up to the allocator bucket size. For example, if your Wasm allocator is known to use power-of-two buckets, <code>roundUpToBucketSize()</code> should return the argument if it is a power-of-two or the next power-of-two otherwise. If the behavior of the Wasm allocator is unknown, <code>roundUpToBucketSize()</code> should be an identity function.</p>

<p>If the behavior of your allocator is unknown, you might want to have up to two reallocation steps and make the first reallocation step multiply the <em>remaining unconverted</em> length by two instead of three. However, in that case, it makes sense not to implement the usual multiplying by two of the <em>already written</em> buffer length, because in such a case if a second reallocation happened, it would always overallocate compared to the original length times three.The above advice assumes that you don't need to allocate space for a zero terminator. That is, on the Wasm side you are working with Rust strings or a non-zero-terminating C++ class. If you are working with C++ <code>std::string</code>, even though the logical length is shown to you, you need to take the extra terminator byte into account when computing rounding up to allocator bucket size. See the next section about C strings.</p>

<h2 id="No_Zero-Termination">No Zero-Termination</h2>

<p>If the input string contains the character U+0000 in the input, <code>encodeInto()</code> will write a 0x00 byte in the output. <code>encodeInto()</code> <em>does not</em> write a C-style 0x00 sentinel byte after the logical output.</p>

<p>If your Wasm program uses C strings, it's your responsibility to write the 0x00 sentinel and you can't prevent your Wasm program from seeing a logically truncated string if the JavaScript string contained U+0000. Observe:</p>

<pre class="brush: js notranslate">var encoder = new TextEncoder;
function encodeIntoWithSentinel(string, u8array, position) {
    var stats = encoder.encodeInto(string, position ? u8array.subarray(position|0) : u8array);
    if (stats.<code>written &lt; </code>u8array.length) u8array[stats.<code>written] = 0; // append null if room</code>
    return stats;
}</pre>

<h2 id="Examples">Examples</h2>

<pre class="brush: html notranslate">&lt;p class="source"&gt;This is a sample paragraph.&lt;/p&gt;
&lt;p class="result"&gt;&lt;/p&gt;</pre>

<pre class="brush: js notranslate">const sourcePara = document.querySelector('.source');
const resultPara = document.querySelector('.result');
const string = sourcePara.textContent;

const textEncoder = new TextEncoder();
const utf8 = new Uint8Array(string.length);

let encodedResults = textEncoder.encodeInto(string, utf8);
resultPara.textContent += 'Bytes read: ' + encodedResults.read +
                          ' | Bytes written: ' + encodedResults.written +
                          ' | Encoded result: ' + utf8;</pre>

<p>{{EmbedLiveSample('Examples')}}</p>

<h2 id="Polyfill">Polyfill</h2>

<p>The polyfill below may be a bit long because of the switch cases and utilization of native TextEncoder.prototype.encode in Safari when available, but it is well worth the length because of the gains in performance.</p>

<pre class="brush: js notranslate">(function(window){
    "use strict";
    var log = Math.log;
    var LN2 = Math.LN2;
    var clz32 = Math.clz32 || function(x) {return 31 - log(x &gt;&gt;&gt; 0) / LN2 | 0};
    var fromCharCode = String.fromCharCode;
    var patchedU8Array = window.Uint8Array || Array;
    var TextEncoderPrototype = TextEncoder["prototype"];
    var GlobalTextEncoder = window["TextEncoder"];
    var globalTextEncoderPrototype;
    var globalTextEncoderInstance;
    //////////////////////////////////////////////////////////////////////////////////////
    function encoderReplacer(nonAsciiChars){
        // make the UTF string into a binary UTF-8 encoded string
        var point = nonAsciiChars.charCodeAt(0)|0;
        if (0xD800 &lt;= point &amp;&amp; point &lt;= 0xDBFF) {
            var nextcode = nonAsciiChars.charCodeAt(1)|0; // defaults to 0 when NaN, causing null replacement character

            if (0xDC00 &lt;= nextcode &amp;&amp; nextcode &lt;= 0xDFFF) {
                //point = ((point - 0xD800)&lt;&lt;10) + nextcode - 0xDC00 + 0x10000|0;
                point = (point&lt;&lt;10) + nextcode - 0x35fdc00|0;
                if (point &gt; 0xffff)
                    return fromCharCode(
                        (0x1e/*0b11110*/&lt;&lt;3) | (point&gt;&gt;&gt;18),
                        (0x2/*0b10*/&lt;&lt;6) | ((point&gt;&gt;&gt;12)&amp;0x3f/*0b00111111*/),
                        (0x2/*0b10*/&lt;&lt;6) | ((point&gt;&gt;&gt;6)&amp;0x3f/*0b00111111*/),
                        (0x2/*0b10*/&lt;&lt;6) | (point&amp;0x3f/*0b00111111*/)
                    );
            } else point = 65533/*0b1111111111111101*/;//return '\xEF\xBF\xBD';//fromCharCode(0xef, 0xbf, 0xbd);
        }
        /*if (point &lt;= 0x007f) return nonAsciiChars;
        else */if (point &lt;= 0x07ff) {
            return fromCharCode((0x6&lt;&lt;5)|(point&gt;&gt;&gt;6), (0x2&lt;&lt;6)|(point&amp;0x3f));
        } else return fromCharCode(
            (0xe/*0b1110*/&lt;&lt;4) | (point&gt;&gt;&gt;12),
            (0x2/*0b10*/&lt;&lt;6) | ((point&gt;&gt;&gt;6)&amp;0x3f/*0b00111111*/),
            (0x2/*0b10*/&lt;&lt;6) | (point&amp;0x3f/*0b00111111*/)
        );
    }
    function TextEncoder(){};
    TextEncoderPrototype["encode"] = function(inputString) {
        // 0xc0 =&gt; 0b11000000; 0xff =&gt; 0b11111111; 0xc0-0xff =&gt; 0b11xxxxxx
        // 0x80 =&gt; 0b10000000; 0xbf =&gt; 0b10111111; 0x80-0xbf =&gt; 0b10xxxxxx
        var encodedString = inputString === void 0 ?  "" : ("" + inputString).replace(/[\x80-\uD7ff\uDC00-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]?/g, encoderReplacer);
        var len=encodedString.length|0, result = new patchedU8Array(len);
        var i=0;
        for (; i&lt;len; i=i+1|0)
            result[i] = encodedString.charCodeAt(i) |0;
        return result;
    };
    function polyfill_encodeInto(inputString, u8Arr) {
        var encodedString = inputString === void 0 ?  "" : ("" + inputString).replace(/[\x80-\uD7ff\uDC00-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]?/g, encoderReplacer);
        var len=encodedString.length|0, i=0, char=0, read=0, u8ArrLen = u8Arr.length|0, inputLength=inputString.length|0;
        if (u8ArrLen &lt; len) len=u8ArrLen;
        putChars: for (; i&lt;len; i=i+1|0) {
            char = encodedString.charCodeAt(i) |0;
            switch(char &gt;&gt;&gt; 4) {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                    read = read + 1|0;
                    // extension points:
                case 8:
                case 9:
                case 10:
                case 11:
                    break;
                case 12:
                case 13:
                    if ((i+1|0) &lt; u8ArrLen) {
                        read = read + 1|0;
                        break;
                    }
                case 14:
                    if ((i+2|0) &lt; u8ArrLen) {
                        read = read + 1|0;
                        break;
                    }
                case 15:
                    if ((i+3|0) &lt; u8ArrLen) {
                        read = read + 1|0;
                        break;
                    }
                default:
                    break putChars;
            }
            //read = read + ((char &gt;&gt;&gt; 6) !== 2) |0;
            u8Arr[i] = char;
        }
        return {"written": i, "read": inputLength &lt; read ? inputLength : read};
    };
    TextEncoderPrototype["encodeInto"] = polyfill_encodeInto;

    if (!GlobalTextEncoder) {
        window["TextEncoder"] = TextEncoder;
    } else if (!(globalTextEncoderPrototype = GlobalTextEncoder["prototype"])["encodeInto"]) {
        globalTextEncoderInstance = new GlobalTextEncoder;
        globalTextEncoderPrototype["encodeInto"] = function(string, u8arr) {
            // Unfortunately, there's no way I can think of to quickly extract the number of bits written and the number of bytes read and such
            var strLen = string.length|0, u8Len = u8arr.length|0;
            if (strLen &lt; ((u8Len &gt;&gt; 1) + 3|0)) { // in most circumstances, this means its safe. there are still edge-cases which are possible
                // in many circumstances, we can use the faster native TextEncoder
                var res8 = globalTextEncoderInstance["encode"](string);
                var res8Len = res8.length|0;
                if (res8Len &lt; u8Len) { // if we dont have to worry about read/written
                    u8arr.set( res8 );
                    return {
                        "read": strLen,
                        "written": res8.length|0
                    };
                }
            }
            return polyfill_encodeInto(string, u8arr);
        };
    }
})(typeof global == "" + void 0 ? typeof self == "" + void 0 ? this : self : global);
</pre>

<p>Source: <a href="https://github.com/anonyco/FastestSmallestTextEncoderDecoder">https://github.com/anonyco/FastestSmallestTextEncoderDecoder</a></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Encoding", "#dom-textencoder-encodeinto", "TextEncoder.encode()")}}</td>
   <td>{{Spec2("Encoding")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.TextEncoder.encodeInto")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{DOMxRef("TextEncoder")}} interface it belongs to.</li>
 <li>{{DOMxRef("TextEncoder.encode()")}}</li>
</ul>
